package org.bitbucket.zetro.squaredino.backend;

import java.util.Arrays;
import java.util.List;

/**
 * Implementation of Brian's Brain.
 */
public class BriansBrain extends CellularAutomaton {
	/**
	 * States.
	 */
	public static final Cell OFF = null,
			ON = Cell.createCell(1),
			DYING = Cell.createCell(2);

	@Override
	public List<Cell> getStates() {
		return Arrays.asList(ON, DYING, OFF);
	}

	@Override
	public Cell getNextState(Cell cell, Cell... neighbours) {
		if (cell == null) {
			if (getCount(neighbours, ON) == 2) {
				return ON;
			} else {
				return cell;
			}
		} else if (cell.equals(ON)) {
			return DYING;
		} else if (cell.equals(DYING)) {
			return OFF;
		}
		System.err.println("Warning: Invalid cell " + cell);
		return OFF;
	}

	@Override
	public String getRule() {
		return null;
	}
}
