package org.bitbucket.zetro.squaredino.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.util.ArrayList;

import javax.swing.JToolBar;

public class GraphPanel extends JToolBar {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1332731254210640722L;
	
	private ArrayList<Integer> values;
	private int stepUpdate = 4; 
	private int step = 0; 
	private int maxvalue = 1;   //The highest value in the list
	public GraphPanel() {
		setSize(new Dimension(800, 100));
		setMinimumSize(new Dimension(800, 100)); 
		setMaximumSize(new Dimension(800, 100)); 
		setPreferredSize(new Dimension(800, 100)); 
		
		values = new ArrayList<Integer>(); 
	}
	
	/**
	 * Sets the number of steps between each update. 
	 * @param i the number of steps
	 */
	public void setStepUpdate(int i) {
		stepUpdate = i; 
	}
	/**
	 * Removes all values. 
	 */
	public void clear() {
		values = new ArrayList<Integer>(); 
		maxvalue = 0; 
		step = 0; 
		repaint(); 
	}
	public void addValue(int i) {
		values.add(0, i);
		step++; 
		if(i >= maxvalue)
			maxvalue = i; 
		if(step%stepUpdate == 0) {
//			step = 0; 
			while(values.size() > 1200)
				values.remove(1200); 
			repaint(); 
		}
	}
	public void paintComponent(Graphics g) {
		g.setColor(Color.WHITE); 
		g.fillRect(0, 0, getWidth(), getHeight()); 
		
		/* Draw axes */
		g.setColor(Color.BLACK);
		g.drawLine(16, getHeight()-16, 16, 16); 
		g.drawLine(16, 16, 16-2, 16+4); //Arrows
		g.drawLine(16, 16, 16+2, 16+4); 
		g.drawLine(16, getHeight()-16, getWidth()-16, getHeight()-16); 
		g.drawLine(getWidth()-16, getHeight()-16, getWidth()-16-4, getHeight()-16-2); 
		g.drawLine(getWidth()-16, getHeight()-16, getWidth()-16-4, getHeight()-16+2); 
		
		g.setFont(new Font("DejaVu", Font.PLAIN, 11)); 
		g.drawString("Gen: "+step, getWidth()-96, 12); 
		
		/* Draw values */
		g.setColor(Color.GREEN); 
		for(int i=0;i<values.size() && i<getWidth();i++) {
			int value = values.get(i); 
			g.drawRect(getWidth()-16-i, (int)(getHeight()-16-((double)value/maxvalue*(getHeight()-32))), 1, 1);
		}
	}
 }
