package org.bitbucket.zetro.squaredino.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.bitbucket.zetro.squaredino.backend.Board;
import org.bitbucket.zetro.squaredino.backend.BoardFactory;

public class RuleDialog extends JDialog {
	
	private static final long serialVersionUID = 9023638966334226345L;

	private Board board; 
	
	private JLabel current; 
	private JTextField text; 
	private JButton change;
	
	public RuleDialog(Board b) {
		board = b; 
		setTitle("Change rule"); 
		setSize(400, 200); 
		setResizable(false); 
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setLocationRelativeTo(null); 
		
		current = new JLabel("Current rule: " + board.getRuleAsString());
		
		text = new JTextField(16); 
		text.setMaximumSize(new Dimension(32, 24)); 
		text.setAlignmentX(Box.CENTER_ALIGNMENT); 
		JPanel t = new JPanel(); 
		
		t.setLayout(new BoxLayout(t, BoxLayout.LINE_AXIS)); 
		t.add(Box.createHorizontalGlue());
		t.add(current); 
		t.add(Box.createHorizontalGlue()); 
		
		JPanel te = new JPanel(); 
		te.add(Box.createHorizontalGlue());
		te.add(new JLabel("New rule: ")); 
		te.add(text); 
		te.add(Box.createHorizontalGlue()); 
		
		change = new JButton("Change");
		change.setAlignmentX(Box.RIGHT_ALIGNMENT); 
		change.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					board.setRule(text.getText()); 
					dispose(); 
				}
				catch(IllegalArgumentException ae) {
				}
			}
		});
		JPanel c = new JPanel(); 
		c.setLayout(new BoxLayout(c, BoxLayout.LINE_AXIS)); 
		c.add(Box.createHorizontalGlue()); 	
		c.add(change); 
		c.add(Box.createHorizontalGlue()); 	
		
		Box box = Box.createVerticalBox(); 
		
		box.add(Box.createVerticalGlue()); 
		box.add(t);
		box.add(te); 
		box.add(Box.createVerticalGlue()); 
		box.add(c); 
		box.add(Box.createVerticalGlue()); 
		
		add(box); 
		
		setVisible(true); 
	}
	public static void main(String[] args) {
		new RuleDialog(BoardFactory.createBoard()); 
	}
}
