package org.bitbucket.zetro.squaredino.misc;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;

/**
 * A collection of useful static methods. 
 * @author mackan
 *
 */
public class Misc {
	public static final Color BG_COLOR = new Color(150, 150, 150); 
	/**
	 * Draws a background on the button icon to use as the pressed version.
	 * @param i The icon that it's based on
	 * @return The icon with a background
	 */
	public static ImageIcon pressedButtonIcon(ImageIcon i) {
		/* Make a dark image with the image icon on top and make that the push animation */
		BufferedImage pressed = new BufferedImage(i.getIconWidth(), i.getIconHeight(), BufferedImage.TYPE_INT_ARGB); 
		Graphics g = pressed.getGraphics(); 
		g.setColor(BG_COLOR);
		g.fillRect(0, 0, pressed.getWidth(), pressed.getHeight()); 
		g.drawImage(i.getImage(), 0, 0, g.getColor(), null); 
		return new ImageIcon(pressed); 
	}
}
