package org.bitbucket.zetro.squaredino.misc;

/**
 * Very basic immutable Point class.
 */
public class Point {
	/**
	 * Point coordinate
	 */
	public final int x, y;

	/**
	 * Point constructor.
	 * 
	 * @param x x-coordinate
	 * @param y y-coordinate
	 */
	public Point(int x, int y) {
		this.x = x;
		this.y = y;
	}

	@Override
	public boolean equals(Object o) {
		if (o instanceof Point) {
			Point p = (Point) o;
			return this.x == p.x && this.y == p.y;
		}
		return false;
	}

	@Override
	public int hashCode() {
		return x * 32713 + y;
	}

	@Override
	public String toString() {
		return "(" + x + ", " + y + ")";
	}
}
